
Ruby - Feature #19068

Upgrades required Bison version for development

10/18/2022 08:52 AM - yui-knk (Kaneko Yuichiro)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

Description

Background

Printing node type, e.g. NODE_LIT, for yydebug option is helpful when developing parse.y.

Before:

Reducing stack by rule 639 (line 5062):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: )

 After:

Reducing stack by rule 641 (line 5078):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: NODE_LIT)

 

Consideration

IIRC, CRuby tries to keep it be able to build with old Bison, I guess this is because default Bison for Mac is very old (might be 2.3).

However Bison is still developed and new version has new feature. Therefore I want to confirm it is able to update Bison version

required for CRuby development.

Implementation

https://github.com/ruby/ruby/pull/6579

Associated revisions

Revision f7db1affd10767d729866e95c02ffb26266829ab - 11/08/2022 03:30 AM - yui-knk (Kaneko Yuichiro)

Set default %printer for NODE nterms

Before:

Reducing stack by rule 639 (line 5062):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: )

 After:

Reducing stack by rule 641 (line 5078):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: NODE_LIT)

 "<*>" is supported by Bison 2.3b (2008-05-27) or later.

https://git.savannah.gnu.org/cgit/bison.git/commit/?id=12e3584054c16ab255672c07af0ffc7bb220e8bc

Therefore developers need to install Bison 2.3b+ to build ruby from

source codes if their Bison is older.

Minimum version requirement for Bison is changed to 3.0.

See: https://bugs.ruby-lang.org/issues/19068 [Feature #19068]
Revision f7db1affd10767d729866e95c02ffb26266829ab - 11/08/2022 03:30 AM - yui-knk (Kaneko Yuichiro)

Set default %printer for NODE nterms

Before:

Reducing stack by rule 639 (line 5062):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: )

 After:

Reducing stack by rule 641 (line 5078):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: NODE_LIT)

 "<*>" is supported by Bison 2.3b (2008-05-27) or later.

https://git.savannah.gnu.org/cgit/bison.git/commit/?id=12e3584054c16ab255672c07af0ffc7bb220e8bc

Therefore developers need to install Bison 2.3b+ to build ruby from

source codes if their Bison is older.

Minimum version requirement for Bison is changed to 3.0.

See: https://bugs.ruby-lang.org/issues/19068 [Feature #19068]

Revision f7db1aff - 11/08/2022 03:30 AM - yui-knk (Kaneko Yuichiro)

Set default %printer for NODE nterms

Before:

Reducing stack by rule 639 (line 5062):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: )

 After:

Reducing stack by rule 641 (line 5078):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: NODE_LIT)

 "<*>" is supported by Bison 2.3b (2008-05-27) or later.

https://git.savannah.gnu.org/cgit/bison.git/commit/?id=12e3584054c16ab255672c07af0ffc7bb220e8bc

Therefore developers need to install Bison 2.3b+ to build ruby from

source codes if their Bison is older.

Minimum version requirement for Bison is changed to 3.0.

See: https://bugs.ruby-lang.org/issues/19068 [Feature #19068]

Revision 5a4d9f91c4678a4b821fc9cc3be77058b1235bf9 - 11/09/2022 11:20 PM - yui-knk (Kaneko Yuichiro)

Update required Bison version in building_ruby.md [ci skip]

See [Feature #19068] for the context.

Revision 5a4d9f91c4678a4b821fc9cc3be77058b1235bf9 - 11/09/2022 11:20 PM - yui-knk (Kaneko Yuichiro)

Update required Bison version in building_ruby.md [ci skip]

See [Feature #19068] for the context.

Revision 5a4d9f91 - 11/09/2022 11:20 PM - yui-knk (Kaneko Yuichiro)

Update required Bison version in building_ruby.md [ci skip]

See [Feature #19068] for the context.

History

#1 - 10/18/2022 09:08 AM - yui-knk (Kaneko Yuichiro)

- Subject changed from Print NODE type with yydebug option to Upgrades required Bison version for development
#2 - 11/07/2022 03:06 AM - matz (Yukihiro Matsumoto)

Sounds reasonable. What version are you going to use?

Matz.

#3 - 11/07/2022 03:08 AM - yui-knk (Kaneko Yuichiro)

Regarding Bison version, I expect Bison 3.0 or later at the moment.

#4 - 11/07/2022 03:10 AM - matz (Yukihiro Matsumoto)

OK. Go ahead.

Matz.

#5 - 11/08/2022 03:30 AM - yui-knk (Kaneko Yuichiro)

- Status changed from Open to Closed

Applied in changeset git|f7db1affd10767d729866e95c02ffb26266829ab.

Set default %printer for NODE nterms

Before:

Reducing stack by rule 639 (line 5062):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: )

 After:

Reducing stack by rule 641 (line 5078):

   $1 = token "integer literal" (1.0-1.1: 1)

-> $$ = nterm simple_numeric (1.0-1.1: NODE_LIT)

 "<*>" is supported by Bison 2.3b (2008-05-27) or later.

https://git.savannah.gnu.org/cgit/bison.git/commit/?id=12e3584054c16ab255672c07af0ffc7bb220e8bc

Therefore developers need to install Bison 2.3b+ to build ruby from

source codes if their Bison is older.

Minimum version requirement for Bison is changed to 3.0.

See: https://bugs.ruby-lang.org/issues/19068 [Feature #19068]

#6 - 11/08/2022 11:09 PM - yui-knk (Kaneko Yuichiro)

[note]

Updated rbenv/ruby-build wiki page.

https://github.com/rbenv/ruby-build/wiki/Home/_compare/69f3e1e995fa2cb86cb10b218be6c292a3b4ac66...4358841999b580f9b34a6783f231145b94

490760

#7 - 11/15/2022 02:50 PM - Eregon (Benoit Daloze)

This broke ruby-dev-builder: https://github.com/ruby/ruby-dev-builder/actions/runs/3464389673/jobs/5785863246

I'll try if brew install bison is enough.

I hope it isn't needed to prepend bison to PATH, otherwise we'll need changes in all Ruby installers.

For reference, the commit on GitHub: https://github.com/ruby/ruby/commit/f7db1affd10767d729866e95c02ffb26266829ab

#8 - 11/15/2022 02:52 PM - Eregon (Benoit Daloze)

@yui-knk (Kaneko Yuichiro) Just installing bison is not enough on macOS:

https://github.com/ruby/ruby-dev-builder/actions/runs/3471482135/jobs/5801034797

So I think you need to make PRs to all Ruby installers otherwise Ruby 3.2 won't build anymore on macOS.

This is quite unfortunate, IMHO it might be reason enough to revert this change, because it's going to be messy to deal with this in every script

building Ruby.

#9 - 11/15/2022 03:02 PM - Eregon (Benoit Daloze)
Although because bison is only needed for development/non-release builds it's a smaller concern.

So then it's needed to fix ruby-build 3.2.0-dev some/prefix and rvm install ruby-head to use the Homebrew bison on macOS.

#10 - 11/15/2022 11:25 PM - yui-knk (Kaneko Yuichiro)

Thanks for sharing.

I think brew install bison is enough because the command install bison@3.8 now.

It seems your fix works well, https://github.com/ruby/ruby-dev-builder/commit/1cdfbf1ebb4d417d43f968b35a416fba5987a3f0.
